<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formTourHouseKnowledgeInfoRef"
      :model="formData"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormTourHouseKnowledgeInfo()" @reset="resetFormTourHouseKnowledgeInfo">
        <el-form-item label="知识类型">
          <el-select
            class="filter-item"
            v-model="formFilter.typeFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="typeFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in typeFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="知识标题">
          <el-input
            class="filter-item"
            v-model="formFilter.titleFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
        <el-form-item label="是否启用">
          <el-select
            class="filter-item"
            v-model="formFilter.enableFilter"
            placeholder=""
            :clearable="true"
            :filterable="true"
            @visible-change="enableFilterWidget.onVisibleChange"
          >
            <el-option
              v-for="item in enableFilterWidgetDropdownList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formTourHoeseKnowledgeInfoTable"
      class="page-table"
      :data="formTourHoeseKnowledgeInfoTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formTourHoeseKnowledgeInfoTableWidgetCurrentPage - 1) * formTourHoeseKnowledgeInfoTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formTourHoeseKnowledgeInfoTableWidget.onSortChange"
      @refresh="formTourHoeseKnowledgeInfoTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onAddTourHoeseKnowledgeInfoClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onExportTourHoeseKnowledgeInfoClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :on-change="onImportTourHoeseKnowledgeInfoClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formTourHoeseKnowledgeInfoTableWidget.getTableIndex" :width="80" />
      <vxe-column title="主键" field="id" sortable />
      <vxe-column title="知识类型 " field="typeDictMap.name" />
      <vxe-column title="知识标题" field="title" />
      <!-- <vxe-column title="知识内容" field="content" /> -->
      <vxe-column title="是否启用" field="enableDictMap.name" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditTourHoeseKnowledgeInfoClick(scope.row)"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteTourHoeseKnowledgeInfoClick(scope.row)"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formTourHoeseKnowledgeInfoTableWidgetTotalCount"
            :current-page="formTourHoeseKnowledgeInfoTableWidgetCurrentPage"
            :page-size="formTourHoeseKnowledgeInfoTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formTourHoeseKnowledgeInfoTableWidget.onCurrentPageChange"
            @size-change="formTourHoeseKnowledgeInfoTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formTourHouseKnowledgeInfo',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourHoeseKnowledgeInfoData } from '@/api/generated/tourHoeseKnowledgeInfoController';
import { TourHoeseKnowledgeInfoController } from '@/api/generated';
import FormEditTourHouseKnowledgeInfo from '@/pages/HouseKnowledgeInfo/formEditTourHouseKnowledgeInfo.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 知识类型
  typeFilter: undefined,
  // 知识标题
  titleFilter: undefined,
  // 是否启用
  enableFilter: undefined,
});
const formFilterCopy = reactive({
  // 知识类型
  typeFilter: undefined,
  // 知识标题
  titleFilter: undefined,
  // 是否启用
  enableFilter: undefined,
});

const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormTourHouseKnowledgeInfo();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormTourHoeseKnowledgeInfoTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    tourHoeseKnowledgeInfoDtoFilter: {
      type: formFilter.typeFilter,
      title: formFilter.titleFilter,
      enable: formFilter.enableFilter,
    }
  };
  return new Promise((resolve, reject) => {
    TourHoeseKnowledgeInfoController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormTourHoeseKnowledgeInfoTableVerify = () => {
  formFilterCopy.typeFilter = formFilter.typeFilter;
  formFilterCopy.titleFilter = formFilter.titleFilter;
  formFilterCopy.enableFilter = formFilter.enableFilter;
  return true;
};
/**
 * 新建
 */
const onAddTourHoeseKnowledgeInfoClick = (row?: TourHoeseKnowledgeInfoData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditTourHouseKnowledgeInfo, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourHoeseKnowledgeInfoTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditTourHoeseKnowledgeInfoClick = (row?: TourHoeseKnowledgeInfoData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditTourHouseKnowledgeInfo, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourHoeseKnowledgeInfoTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportTourHoeseKnowledgeInfoClick = (row?: TourHoeseKnowledgeInfoData) => {
  let params: ANY_OBJECT = {
  };

  TourHoeseKnowledgeInfoController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportTourHoeseKnowledgeInfoClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  TourHoeseKnowledgeInfoController.import(params).then(res => {
    ElMessage.success('导入成功');
    formTourHoeseKnowledgeInfoTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteTourHoeseKnowledgeInfoClick = (row?: TourHoeseKnowledgeInfoData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    TourHoeseKnowledgeInfoController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formTourHoeseKnowledgeInfoTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formTourHoeseKnowledgeInfoTableOptions: TableOptions<TourHoeseKnowledgeInfoData> = {
  loadTableData: loadFormTourHoeseKnowledgeInfoTableWidgetData,
  verifyTableParameter: loadFormTourHoeseKnowledgeInfoTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formTourHoeseKnowledgeInfoTable = ref();
const formTourHoeseKnowledgeInfoTableWidget = useTable(formTourHoeseKnowledgeInfoTableOptions);
const {
  dataList: formTourHoeseKnowledgeInfoTableWidgetDataList,
  currentPage: formTourHoeseKnowledgeInfoTableWidgetCurrentPage,
  pageSize: formTourHoeseKnowledgeInfoTableWidgetPageSize,
  totalCount: formTourHoeseKnowledgeInfoTableWidgetTotalCount,
} = formTourHoeseKnowledgeInfoTableWidget;
/**
 * 知识类型下拉数据获取函数
 */
const loadTypeFilterDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    DictionaryController.dictGlobalDict({ dictCode: 'HouseKnowledgeType', itemIdType: 'Integer' }).then(res => {
      resolve({
        dataList: res.getList(),
      });
    }).catch(e => {
      reject(e);
    });
  });
};
// 知识类型配置参数
const typeFilterOptions: DropdownOptions<DictData> = {
  loadData: loadTypeFilterDropdownList,
  isTree: false,
};
// 知识类型下拉组件
const typeFilterWidget = useDropdown(typeFilterOptions);
const { dropdownList: typeFilterWidgetDropdownList } = typeFilterWidget
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableFilterDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableFilterOptions: DropdownOptions<DictData> = {
  loadData: loadEnableFilterDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableFilterWidget = useDropdown(enableFilterOptions);
const { dropdownList: enableFilterWidgetDropdownList } = enableFilterWidget
const refreshFormTourHouseKnowledgeInfo = () => {
  // 刷新段落
  formTourHoeseKnowledgeInfoTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormTourHouseKnowledgeInfo = () => {
  formFilter.typeFilter = undefined;
  formFilterCopy.typeFilter = undefined;
  formFilter.titleFilter = undefined;
  formFilterCopy.titleFilter = undefined;
  formFilter.enableFilter = undefined;
  formFilterCopy.enableFilter = undefined;
  refreshFormTourHouseKnowledgeInfo();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormTourHouseKnowledgeInfo();
};
const formInit = () => {
  typeFilterWidget.onVisibleChange(true).catch(e => {console.error(e)});
  enableFilterWidget.onVisibleChange(true).catch(e => {console.error(e)});
  refreshFormTourHouseKnowledgeInfo();
};

onMounted(() => {
  formInit();
});
</script>